#include <stdio.h>
#ifndef PUZZLE_H
#define PUZZLE_H

#define PUZZLE_MAX_N 100


#include <string>
#include <iostream>
#include <fstream>
#include <vector>
#include "PuzzleInputFce.h"

using std::vector;

typedef std::pair<int,unsigned int> SOUSED;			
// dvojice < CISLO_KAMENE , POZICE >

class Puzzle
{
public:
	Puzzle();
	Puzzle(const Puzzle& p2);
	~Puzzle();

	void ResetTiles();
	void ResetTiles(unsigned int n);
	unsigned int ManhattanDist() const;

	bool CanTrim() const;			// jestli je 1. radek a 1. doplnen spravne
	bool TrimBoard();				// oreze plochu o 1. radek a 1. sloupec a precisluje kameny
	bool DoMove(const char move);	// pokusi se provest 1 tah danym smerem
	bool ApplySequence(const std::string sequence);
	unsigned int CountZeroPosition();
	unsigned int CountZeroPosition() const;
	bool IsSolvable() const;
	void PositionToCoord(int pos, int &row, int &col) const;
	bool RandomMove();				// udela 1 nahodny pohyb


	// I/O
	void Print() const;
	bool LoadFromSbp(std::string filename);
	bool SaveToSbp(std::string filename);
	bool DirectLoad(std::string filename);
	
	// Gettery:
	int operator[](unsigned int pos) const;
	unsigned int GetPosition(int tile) const;
	unsigned int GetGoalPosition(int tile) const;
	unsigned int GetN() const;
	inline unsigned int GetZeroPosition() const { return this->zeroPosition; }
	void		 GetNeighbours(unsigned int position, vector<SOUSED>& sousedi) const;

	// Settery:
	unsigned int SetN(unsigned int n2);
	unsigned int SetZeroPosition(unsigned int zeroPosition2);
	void		 SetTiles(const vector<int>& newTiles);
	


	vector<int> tiles;

private:

	bool LoadXml(TiXmlDocument* doc);
	
	
	// ***** VARIABLES *****
	unsigned int n;
	unsigned int n_orig;
	vector<int> tiles_orig;

	unsigned int zeroPosition;


};


// --------------------------------------------------------------------------------- //
//					P O M O C N E   F U N K C E										 //
// --------------------------------------------------------------------------------- //

const char DetermineDirection(int pos1, int pos2, unsigned int n);

#endif